#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire2500seven4xi .py">
#<abstract4xi abstract = "fires to direction seven and to distance 2500"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2500seven4xi ']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
       
# -------------------------------------------------------------------------------------------------
# SHOT2SEVEN - COORDINATE SIGNS OF SHOOT2SEVEN4XI: (X - ,Y - ,Z + )
# -------------------------------------------------------------------------------------------------    
global shot2seven25004xi

#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False
shot2seven25004xi = {
                1:'-1013x-612y2201z',
                2:'-1024x-548y2213z',
                3:'-102x-1277y2146z',
                4:'-1032x-484y2224z',
                5:'-1035x-421y2236z',
                6:'-104x-2235y1115z',
                7:'-1053x-1849y1311z',
                8:'-1071x-2102y827z',
                9:'-1141x-1780y1332z',
                10:'-1175x-2035y850z',
                11:'-1225x-1707y1354z',
                12:'-126x-2414y635z',
                13:'-1275x-1964y874z',
                14:'-1277x-2148y5z',
                15:'-1304x-1630y1374z',
                16:'-1371x-1887y897z',
                17:'-1378x-1549y1395z',
                18:'-1388x-2078y30z',
                19:'-1448x-1465y1416z',
                20:'-1462x-1806y920z',
                21:'-1495x-2002y55z',
                22:'-1512x-1377y1436z',
                23:'-1548x-1720y943z',
                24:'-1571x-1287y1457z',
                25:'-1597x-1921y80z',
                26:'-1624x-1194y1477z',
                27:'-1630x-1630y967z',
                28:'-166x-1249y2158z',
                29:'-1672x-1100y1497z',
                30:'-1695x-1834y105z',
                31:'-1705x-1536y990z',
                32:'-1714x-1003y1517z',
                33:'-1751x-905y1537z',
                34:'-1776x-1438y1012z',
                35:'-1782x-805y1557z',
                36:'-1788x-1742y130z',
                37:'-1807x-705y1576z',
                38:'-1826x-605y1595z',
                39:'-1840x-1337y1035z',
                40:'-1840x-504y1615z',
                41:'-1848x-404y1634z',
                42:'-1875x-1645y155z',
                43:'-1899x-1233y1058z',
                44:'-1952x-1127y1081z',
                45:'-1957x-1543y180z',
                46:'-1998x-1018y1103z',
                47:'-2034x-1438y205z',
                48:'-2039x-907y1125z',
                49:'-2073x-795y1148z',
                50:'-2100x-682y1170z',
                51:'-2105x-1328y230z',
                52:'-2122x-568y1192z',
                53:'-2137x-454y1214z',
                54:'-2146x-339y1236z',
                55:'-2148x-225y1257z',
                56:'-2169x-1215y255z',
                57:'-219x-2215y1137z',
                58:'-2227x-1099y280z',
                59:'-2279x-979y305z',
                60:'-227x-1217y2171z',
                61:'-2324x-858y329z',
                62:'-2363x-734y354z',
                63:'-2394x-608y379z',
                64:'-23x-24y2499z',
                65:'-24x-356y2474z',
                66:'-252x-2398y660z',
                67:'-285x-1183y2183z',
                68:'-333x-2189y1159z',
                69:'-340x-1145y2195z',
                70:'-35x-1302y2133z',
                71:'-376x-2374y684z',
                72:'-37x-45y2499z',
                73:'-392x-1105y2207z',
                74:'-39x-330y2477z',
                75:'-441x-1062y2219z',
                76:'-445x-2157y1181z',
                77:'-487x-1018y2230z',
                78:'-498x-2345y708z',
                79:'-50x-67y2498z',
                80:'-529x-971y2241z',
                81:'-52x-303y2480z',
                82:'-554x-2119y1203z',
                83:'-567x-923y2252z',
                84:'-5x-382y2470z',
                85:'-602x-873y2263z',
                86:'-60x-90y2497z',
                87:'-618x-2308y732z',
                88:'-633x-823y2274z',
                89:'-63x-276y2483z',
                90:'-660x-771y2284z',
                91:'-661x-2076y1225z',
                92:'-684x-719y2294z',
                93:'-68x-114y2496z',
                94:'-699x-128y2396z',
                95:'-6x-6y2499z',
                96:'-704x-666y2304z',
                97:'-70x-248y2486z',
                98:'-714x-170y2389z',
                99:'-720x-614y2313z',
                100:'-727x-214y2382z',
                101:'-733x-561y2323z',
                102:'-736x-2266y755z',
                103:'-738x-260y2374z',
                104:'-742x-509y2332z',
                105:'-745x-307y2366z',
                106:'-748x-457y2341z',
                107:'-749x-356y2358z',
                108:'-74x-140y2494z',
                109:'-750x-406y2349z',
                110:'-75x-221y2489z',
                111:'-764x-2027y1247z',
                112:'-77x-166y2493z',
                113:'-77x-193y2491z',
                114:'-851x-2217y779z',
                115:'-864x-1972y1268z',
                116:'-955x-805y2165z',
                117:'-960x-1913y1290z',
                118:'-962x-2162y803z',
                119:'-964x-904y2238z',
                120:'-979x-741y2177z',
                121:'-998x-677y2189z',
                122:'0x-2424y611z'}         
#"
#/>


# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire2500seven4xi " usage = "target function for charge2seven4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire2500seven4xi (queue2seven, consumer_channel2seven, publisher_channel2seven):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE2500SEVEN4XI - STARTED TIME: ", time2start)
        #  
        
        print("\n (STEP 1A2/33) OF FIRE2500SEVEN4XI -  QUEUE2SEVEN: ", queue2seven)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE2500SEVEN4XI -  CONSUMER_CHANNEL2SEVEN: ", consumer_channel2seven)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE2500SEVEN4XI -  PUBLISHER_CHANNEL2SEVEN: ", publisher_channel2seven)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE2500SEVEN4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2SEVEN: ", queue2seven, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2seven.put(shot2seven25004xi) 
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE2500SEVEN4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2SEVEN: ", queue2seven, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE2500SEVEN4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2SEVEN: ", queue2seven, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE2500SEVEN4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2SEVEN: ", publisher_channel2seven, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2seven8shot2seven25004xi </ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2seven8shot2seven25004xi </nack2put4xi>" 
            
        publisher_channel2seven.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE2500SEVEN4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2SEVEN: ", publisher_channel2seven, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE2500SEVEN4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2SEVEN: ", publisher_channel2seven, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE2500SEVEN4XI - RETURNING QUEUE OBJECT QUEUE2SEVEN: ", queue2seven, " - TIME: ", time4xi())  
        # 
            
    return queue2seven    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire2500seven4xi .py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>

       